﻿using System;
using System.Text;
using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GestioHospitalaria.Controllers;
using MvcContrib.TestHelper;
using GestioHospitalaria.Auxiliar;
using GestioHospitalaria.Models;
using GestioHospitalaria.Tests;
using System.Web.Mvc;

namespace GestioHospitalaria.Tests.Controllers
{
    /// <summary>
    /// Descripción resumida de ModificarContrasenyaControllerTest
    /// </summary>
    [TestClass]
    public class ModificarContrasenyaControllerTest
    {
        public ModificarContrasenyaControllerTest()
        {
            //
            // TODO: Agregar aquí la lógica del constructor
            //
        }
        //Accedim com a Administrador i canviem la contrasenya
        [TestMethod]
        public void ChangePassword_LoginAdminOK()
        {
            // Arrange
            ModificarContrasenyaController controller = new ModificarContrasenyaController();
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            ModificarContrasenyaModel model = Auxiliar.Auxiliar.GetModificarContrasenyaModel();
            // Act
            var resultLogin = (RedirectToRouteResult)controller.IndexSQL(model,true);

            // Assert

            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//Tornem a la pàgina principal de l'aplicació
        }
        //Tenim un error al canviar la contrasenya
        [TestMethod]
        public void ChangePassword_LoginAdminNoOK()
        {
            // Arrange
            ModificarContrasenyaController controller = new ModificarContrasenyaController();
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            ModificarContrasenyaModel model = Auxiliar.Auxiliar.GetModificarContrasenyaModelError();
            // Act
            var resultLogin = (ViewResult)controller.Index(model,true);

            // Assert

            Assert.AreEqual(null, resultLogin.ViewBag.Message);//tornem a la pàgina de canvi de contrasenya amb un error
        }
 

    }
}
