﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using GestioHospitalaria.Models;
using GestioHospitalaria.Auxiliar;

namespace GestioHospitalaria.Controllers
{
    public class HomeAdministradorController : Controller
    {
        
        IGestioHospitalariaRepository _repository;
        //L'arxiu StructureMaps.xml determinarà el comportament de repository
        public HomeAdministradorController(IGestioHospitalariaRepository repository)
        {
            _repository = repository;
            
        }
        //
        // GET: /HomeAdministrador/
        public ActionResult Index()
        {
            try
            {
                if (Auxiliar.Auxiliar.is_Authorized(Session, "1"))
                {
                    ViewBag.MessageOK = "Usuari OK";
                    return View();
                }
                else
                {
                    return RedirectToAction("Logout", "Account");
                }
            }
            catch
            {
                ViewBag.Message = "Error no controlat";
                return RedirectToAction("Logout", "Account");
            }
        }

    }
}
