﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using System.Data.SqlClient;
using GestioHospitalaria.Auxiliar;

namespace GestioHospitalaria.Models
{
    public class AccountModel
    {

        private BD_GestioHospitalariaEntities db;
        [Required(ErrorMessage = "El camp {0} és obligatori")]
        [Display(Name = "Nom d'Usuari")]
        public string UserName { get; set; }

        [Required(ErrorMessage = "El camp {0} és obligatori")]
        [DataType(DataType.Password)]
        [Display(Name = "Contrasenya")]
        public string Password { get; set; }

        [Display(Name = "Recorda'm")]
        public bool RememberMe { get; set; }
        public Usuari IsValid(string _username, string _pwd)
        {//retornamem el tipus d'usuari, x
            string _sql = "Select * From Usuari Where NomUsuari='" + _username + "' And Contrasenya='" + Auxiliar.Auxiliar.EncodeMD5(_pwd) + "'";
            string st = System.Configuration.ConfigurationManager.ConnectionStrings["BD_GestioHospitalaria"].ConnectionString;
            SqlConnection cn = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["BD_GestioHospitalaria"].ConnectionString);
            cn.Open();
            SqlCommand cmd = new SqlCommand(_sql, cn);
            SqlDataReader dr = cmd.ExecuteReader();
            if (dr.Read())
            {
                Usuari usuari = new Usuari();
                usuari.ID_Usuari = Convert.ToInt32(dr["ID_Usuari"].ToString());
                usuari.ID_TipusEmpleat= Convert.ToInt32(dr["ID_TipusEmpleat"].ToString ());
                usuari.NomUsuari = dr["NomUsuari"].ToString();
                usuari.Contrasenya = dr["Contrasenya"].ToString();
                usuari.Nom = dr["Nom"].ToString();
                usuari.Cognom1 = dr["Cognom1"].ToString();
                usuari.Cognom2 = dr["Cognom2"].ToString();
                usuari.Direccio = dr["Direccio"].ToString();
                usuari.Ciutat = dr["Ciutat"].ToString();
                usuari.CodiPostal = dr["CodiPostal"].ToString();
                usuari.Nif = dr["Nif"].ToString();

                return usuari;

            }
            else
                return null;

        }
        public Usuari IsValidEntity(string _username, string _pwd)
        {//retornamem el tipus d'usuari, x
            _pwd = Auxiliar.Auxiliar.EncodeMD5(_pwd);
            db = new BD_GestioHospitalariaEntities();
            var usuari = db.Usuari.Where(u => u.NomUsuari == _username && u.Contrasenya == _pwd);
            if (usuari.Count() > 0) //les dades són correctes
                return (Usuari)usuari.First();
            else
            return null;

        }
    }
}