﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using System.Data.SqlClient;
using GestioHospitalaria.Auxiliar;
using System.Data;
namespace GestioHospitalaria.Models
{
    public class ModificarContrasenyaModel
    {
        private BD_GestioHospitalariaEntities db;
        [Required(ErrorMessage = "El camp {0} és obligatori")]
        [Display(Name = "Nom d'Usuari")]
        public string UserName { get; set; }

        [Required(ErrorMessage = "El camp {0} és obligatori")]
        [DataType(DataType.Password)]
        [Display(Name = "Antiga Contrasenya")]
        public string AntigaContraseny { get; set; }

        [Required(ErrorMessage = "El camp {0} és obligatori")]
        [DataType(DataType.Password)]
        [Display(Name = "Nova Contrasenya")]
        public string NovaContraseny { get; set; }

        [Required(ErrorMessage = "El camp {0} és obligatori")]
        [DataType(DataType.Password)]
        [Display(Name = "Confirmar nova Contrasenya")]
        public string ConfNovaContraseny { get; set; }

        //afegim el bool test per poder fer servir la funcionalitat sense canviar la contrasenya al usuari
        public Usuari IsValid(string _newPassword, string _confNewPassword, string _pwd, string _NomUsuari, bool test)
        {//retornamem el tipus d'usuari, 
            if (_newPassword == _confNewPassword)
            {
                string _sql = "Select * From Usuari Where NomUsuari='" + _NomUsuari + "' And Contrasenya='" + Auxiliar.Auxiliar.EncodeMD5(_pwd) + "'";
            SqlConnection cn = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["BD_GestioHospitalaria"].ConnectionString);
                cn.Open();
                SqlCommand cmd = new SqlCommand(_sql, cn);
                SqlDataReader dr = cmd.ExecuteReader();
                if (dr.Read())
                {
                    Usuari usuari = new Usuari();
                    usuari.ID_Usuari = Convert.ToInt32(dr["ID_Usuari"].ToString());
                    usuari.ID_TipusEmpleat = Convert.ToInt32(dr["ID_TipusEmpleat"].ToString());
                    usuari.NomUsuari = dr["NomUsuari"].ToString();
                    usuari.Contrasenya = Auxiliar.Auxiliar.EncodeMD5(_pwd);
                    usuari.Nom = dr["Nom"].ToString();
                    usuari.Cognom1 = dr["Cognom1"].ToString();
                    usuari.Cognom2 = dr["Cognom2"].ToString();
                    usuari.Direccio = dr["Direccio"].ToString();
                    usuari.Ciutat = dr["Ciutat"].ToString();
                    usuari.CodiPostal = dr["CodiPostal"].ToString();
                    usuari.Nif = dr["Nif"].ToString();


                    cn.Close();
                    if (!test)//si no es un test actualitzem les dades del usuari
                    {
                        _sql = "Update Usuari Set Contrasenya='" + Auxiliar.Auxiliar.EncodeMD5(_confNewPassword) + "' Where NomUsuari='" + _NomUsuari + "' and Contrasenya ='" + Auxiliar.Auxiliar.EncodeMD5(_pwd) + "' ";
                        cn.Open();
                        cmd = new SqlCommand(_sql, cn);
                        dr = cmd.ExecuteReader();
                    }
                    return usuari;

                }
                else
                    return null;
            }
            else return null;

        }

        //afegim el bool test per poder fer servir la funcionalitat sense canviar la contrasenya al usuari
        public Usuari IsValidEntity(string _newPassword, string _confNewPassword, string _pwd, string _NomUsuari, bool test)
        {//retornamem el tipus d'usuari, 
            if (_newPassword == _confNewPassword)
            {
                _pwd = Auxiliar.Auxiliar.EncodeMD5(_pwd);
                db = new BD_GestioHospitalariaEntities();
                var usuari = db.Usuari.Where(u => u.NomUsuari == _NomUsuari && u.Contrasenya == _pwd);
                if (usuari.Count() > 0) //les dades són correctes
                {
                    Usuari usu = (Usuari)usuari.First();

                    if (!test)//si no es un test actualitzem les dades del usuari
                    {
                        usu.Contrasenya = Auxiliar.Auxiliar.EncodeMD5(_confNewPassword);
                        db.Entry(usu).State = EntityState.Modified;
                        db.SaveChanges();
                    }
                    return usu;

                }
                else
                    return null;
            }
            else return null;

        }

    }
}