﻿using System.Web;
using System.Web.Optimization;

namespace GestioHospitalaria
{
    public class BundleConfig
    {


        // Para obtener más información acerca de Bundling, consulte http://go.microsoft.com/fwlink/?LinkId=254725
        public static void RegisterBundles(BundleCollection bundles)
        {
            bundles.Add(new StyleBundle("~/Content/css").Include("~/Content/site.css"));
            bundles.Add(new StyleBundle("~/Auxiliar/css/css").Include("~/Auxiliar/css/bootstrap-datetimepicker.min.css"));
            bundles.Add(new StyleBundle("~/Auxiliar/bootstrap/css/css").Include("~/Auxiliar/bootstrap/css/bootstrap.min.css"));

            bundles.Add(new ScriptBundle("~/bundles/Auxiliar/jquery").Include(
                                    "~/Auxiliar/jquery/jquery-1.8.3.min.js"));
            bundles.Add(new ScriptBundle("~/bundles/Auxiliar/bootstrap").Include(
                                    "~/Auxiliar/bootstrap/js/bootstrap.min.js"));
            bundles.Add(new ScriptBundle("~/bundles/Auxiliar/js/bootstrap").Include(
                                    "~/Auxiliar/js/bootstrap-datetimepicker.js"));
            bundles.Add(new ScriptBundle("~/bundles/Auxiliar/js/locales/bootstrap").Include(
                                    "~/Auxiliar/js/locales/bootstrap-datetimepicker.ca.js"));
        }
    }
}