﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using StructureMap;
using GestioHospitalaria.Models;
using GestioHospitalaria.Auxiliar;

namespace GestioHospitalaria.Controllers
{
    [HandleError]

    public class HomeController : Controller
    {

        IGestioHospitalariaRepository _repository;
        //L'arxiu StructureMaps.xml determinarà el comportament de repository
        public HomeController(IGestioHospitalariaRepository repository)
        {
            _repository = repository;
        }
        //public HomeController() : this(new EntityGestioHospitalariaManagerRepository()) { }

        public ActionResult Index()
        {
            try
            {
                ViewBag.Message = "Benvingut al sistema de Gestió Hospitalària";
                return View();
            }
            catch
            {
                ViewBag.Message = "Error no controlat";
                return RedirectToAction("Logout", "Account");
            }
        }
    }
}
